std::is_signed(3)

NAME
std::is_signed - std::is_signed

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++11)
   struct is_signed;
   If T is an arithmetic type, provides the member constant value equal to true if
   T(-1) < T(0): this results in true for the floating-point types and the signed
   integer types, and in false for the unsigned integer types and the type bool.
   For any other type, value is false.
   The behavior of a program that adds specializations for is_signed
   or is_signed_v
   (since C++17) is undefined.

Template parameters
   T - a type to check
  Helper variable template
   template< class T > (since C++17)
   inline constexpr bool is_signed_v = is_signed<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is a signed arithmetic type , false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
   namespace detail {
   template<typename T,bool = std::is_arithmetic<T>::value>
   struct is_signed : std::integral_constant<bool, T(-1) < T(0)> {};
   template<typename T>
   struct is_signed<T,false> : std::false_type {};
   } // namespace detail
   template<typename T>
   struct is_signed : detail::is_signed<T>::type {};

Example
// Run this code
 #include <iostream>
 #include <type_traits>
 class A {};
 enum B : int {};
 enum class C : int {};
 int main()
 {
     std::cout << std::boolalpha;
     std::cout << std::is_signed<A>::value << '\n'; // false
     std::cout << std::is_signed<float>::value << '\n'; // true
     std::cout << std::is_signed<signed int>::value << '\n'; // true
     std::cout << std::is_signed<unsigned int>::value << '\n'; // false
     std::cout << std::is_signed<B>::value << '\n'; // false
     std::cout << std::is_signed<C>::value << '\n'; // false
     // shorter:
     std::cout << std::is_signed_v<bool> << '\n'; // false
     std::cout << std::is_signed<signed int>() << '\n'; // true
     std::cout << std::is_signed<unsigned int>{} << '\n'; // false
 }

Output:
 false
 true
 true
 false
 false
 false
 false
 true
 false

See also
   is_unsigned checks if a type is an unsigned arithmetic type
   (C++11) (class template)
   is_signed identifies signed types
   [static] (public static member constant of std::numeric_limits<T>)
   is_arithmetic checks if a type is an arithmetic type
   (C++11) (class template)
   make_signed makes the given integral type signed
   (C++11) (class template)
   make_unsigned makes the given integral type unsigned
   (C++11) (class template)